package edu.agh.sm2006.smschess.server.session;

import org.junit.Test;

import junit.framework.TestCase;
import ictk.boardgame.IllegalMoveException;
import ictk.boardgame.chess.ChessBoard;

public class SessionTest extends TestCase {
	private static class TestingSessionImpl extends Session {

		public TestingSessionImpl() {
			super(null, null, null, null);
		}

		@Override
		public void terminate(boolean notify) {
		}

	}

	private Session session = new TestingSessionImpl();

	private ChessBoard chessBoard = session.chessBoard;

	@Test
	public void testMovePromotion() throws IllegalMoveException {
		chessBoard.setPositionClear();
		chessBoard.addPawn(7, 1, false);
		session.move("a7a8q");
		assertTrue(chessBoard.getSquare(8, 1).getOccupant().isQueen());
	}

	@Test
	public void testMoveCastle() throws Exception {
		chessBoard.setPositionClear();
		chessBoard.addRook(1, 1, false);
		chessBoard.addKing(1, 5, false);
		session.move("e1c1");
		assertTrue(chessBoard.getSquare(1, 3).getOccupant().isKing());
		assertTrue(chessBoard.getSquare(1, 4).getOccupant().isRook());
	}
}
