package edu.agh.sm2006.smschess.server;

import edu.agh.sm2006.smschess.server.message.MessageParser;

/**
 * Generic interface that provides communication layer to the server.
 *
 * @author Kuba Madej
 *
 */
public interface Connector {
	/**
	 * Opens connection. Uses given parser to handle incoming messages
	 *
	 * @param chessMessageParser
	 *            parser instance to use
	 */
	void openConnection(MessageParser chessMessageParser);

	/**
	 * Sends a message to a client.
	 *
	 * @param receiver
	 *            String identyfying receiver, its interpretation depends on the
	 *            actual Connector implementation
	 * @param messageContent
	 *            message to send
	 */
	void sendMessage(final String receiver, final String messageContent);

	/**
	 * Runs receiver's loop. This method is expected to never end.
	 *
	 */
	void runReceiver();
}