/**
 *
 */
package edu.agh.sm2006.smschess.server.cimd;

import java.util.Scanner;

import org.apache.log4j.Logger;

import edu.agh.sm2006.smschess.server.cimd.message.Message;
import edu.agh.sm2006.smschess.server.cimd.message.MessageFactory;
import edu.agh.sm2006.smschess.server.cimd.message.MessageHeaderParser;
import edu.agh.sm2006.smschess.server.cimd.message.MessageType;

/**
 * @author Kuba Madej
 *
 */
public class CIMDMessageReceiver {
	private static final Logger logger = Logger
			.getLogger(CIMDMessageReceiver.class);

	private CIMDConnector connector;

	private Scanner scanner;

	public CIMDMessageReceiver(CIMDConnector connector) {
		this.connector = connector;
	}

	/*
	 * (non-Javadoc)
	 *
	 * @see java.lang.Runnable#run()
	 */
	public void run() {
		do {
			scanner = new Scanner(connector.getInputStream(),
					CIMDConnector.ENCODING);
			scanner.useDelimiter("" + CIMDConnector.ETX);
			while (scanner.hasNext()) {
				String stringMessage = scanner.next();
				stringMessage = stringMessage.substring(stringMessage
						.indexOf(CIMDConnector.STX));
				final Message message = MessageFactory
						.getMessage(stringMessage);
				connector.messageReceived(message);
				if (!message.getType().isResponse()) {
					final String messageNumber = MessageHeaderParser
							.getMessageNumber(stringMessage);
					connector
							.sendMessage(new Message(MessageType
									.getResponseType(message.getType())),
									messageNumber);
				}
			}
			logger.warn("Connection closed by SMSC");
			connector.connect();
			connector.login();
		} while (true);
	}
}
