/**
 *
 */
package edu.agh.sm2006.smschess.server.cimd;

import org.apache.commons.lang.builder.ToStringBuilder;
import org.apache.commons.lang.builder.EqualsBuilder;
import org.apache.commons.lang.builder.HashCodeBuilder;

/**
 * @author Kuba Madej
 *
 */
public class CIMDParameter {
	private CIMDParameterType type;

	private String value;

	/**
	 * @param type
	 * @param value
	 */
	public CIMDParameter(CIMDParameterType type, String value) {
		this.type = type;
		this.value = value;
	}

	/**
	 * @return the type
	 */
	public CIMDParameterType getType() {
		return type;
	}

	/**
	 * @return the value
	 */
	public String getValue() {
		return value;
	}

	/**
	 * @see java.lang.Object#toString()
	 */
	public String toString() {
		return new ToStringBuilder(this).append("value", this.value).append(
				"type", this.type).toString();
	}

	/**
	 * @see java.lang.Object#equals(Object)
	 */
	public boolean equals(Object object) {
		if (!(object instanceof CIMDParameter)) {
			return false;
		}
		CIMDParameter rhs = (CIMDParameter) object;
		return new EqualsBuilder().append(this.value, rhs.value).append(
				this.type, rhs.type).isEquals();
	}

	/**
	 * @see java.lang.Object#hashCode()
	 */
	public int hashCode() {
		return new HashCodeBuilder(89427827, -1332345471).append(this.value)
				.append(this.type).toHashCode();
	}
}
