/**
 *
 */
package edu.agh.sm2006.smschess.server.cimd;

import java.util.HashMap;
import java.util.Map;

/**
 * @author Kuba Madej
 *
 */
public enum CIMDParameterType {
	UserIdentity(10),
	Password(11),
	Subaddr(12),
	WindowSize(19),
	DestinationAddress(21),
	OriginatorAddress(23),
	OriginatedIMSI(26),
	AlphanumericOriginatingAddress(27),
	OriginatedVisitedMSCAddress(28),
	DataCodingScheme(30),
	UserDataHeader(32),
	UserData(33),
	UserDataBinary(34),
	MoreMessagesToSend(44),
	ValidityPeriodRelative(50),
	ValidityPeriodAbsolute(51),
	ProtocolIdentifier(52),
	FirstDeliveryTimeRelative(53),
	FirstDeliveryTimeAbsolute(54),
	ReplyPath(55),
	StatusReportRequest(56),
	CancelEnabled(58),
	CancelMode(59),
	ServiceCentreTimeStamp(60),
	StatusCode(61),
	StatusErrorCode(62),
	DischargeTime(63),
	TariffClass(64),
	ServiceDescription(65),
	NumberOfMessagesWaiting(66),
	Priority(67),
	Mode(68),
	ServiceCenterAddress(69),
	TimeOfTheSMSCenter(501),
	ErrorCode(900),
	ErrorText(901);

	private final String typeCode;

	private static Map<String, CIMDParameterType> parameterTypes;

	private static Map<String, CIMDParameterType> getMap() {
		if (parameterTypes == null)
			parameterTypes = new HashMap<String, CIMDParameterType>();
		return parameterTypes;
	}

	private CIMDParameterType(int code) {
		typeCode = String.format("%03d", code);
		getMap().put(typeCode, this);
	}

	public static CIMDParameterType getParameterType(String code) {
		return parameterTypes.get(code);
	}

	public String toString() {
		return typeCode;
	}
}
