/**
 *
 */
package edu.agh.sm2006.smschess.server.cimd.message;

import java.util.HashSet;
import java.util.Set;
import org.apache.commons.lang.builder.ToStringBuilder;

import edu.agh.sm2006.smschess.server.cimd.CIMDParameter;
import edu.agh.sm2006.smschess.server.cimd.CIMDParameterType;
import org.apache.commons.lang.builder.EqualsBuilder;
import org.apache.commons.lang.builder.HashCodeBuilder;

/**
 * @author Kuba Madej
 *
 */
public class Message {
	protected MessageType type;

	protected Set<CIMDParameter> parameters = new HashSet<CIMDParameter>();

	/**
	 * @return the parameters
	 */
	public Set<CIMDParameter> getParameters() {
		return parameters;
	}

	/**
	 * @param type
	 */
	public Message(MessageType type) {
		this.type = type;
	}

	/**
	 * @return the type
	 */
	public MessageType getType() {
		return type;
	}

	public void addParameter(CIMDParameterType type, String value) {
		parameters.add(new CIMDParameter(type, value));
	}

	/**
	 * @see java.lang.Object#toString()
	 */
	public String toString() {
		return new ToStringBuilder(this).append("parameters", this.parameters)
				.append("type", this.type).toString();
	}

	/**
	 * @see java.lang.Object#equals(Object)
	 */
	public boolean equals(Object object) {
		if (!(object instanceof Message)) {
			return false;
		}
		Message rhs = (Message) object;
		return new EqualsBuilder().append(this.parameters, rhs.parameters)
				.append(this.type, rhs.type).isEquals();
	}

	/**
	 * @see java.lang.Object#hashCode()
	 */
	public int hashCode() {
		return new HashCodeBuilder(-127774305, 1000011439).append(
				this.parameters).append(this.type).toHashCode();
	}
}
