/**
 * 
 */
package edu.agh.sm2006.smschess.server.cimd.message;

import edu.agh.sm2006.smschess.server.cimd.CIMDParameterType;

/**
 * @author Kuba Madej
 * 
 */
public class SubmitRequestMessage extends Message {

	final static short COMMUNICATION_PORT = 5000;

	final static String USER_DATA_HEADER;

	static {
		final StringBuilder headerBuilder = new StringBuilder("060504");
		final String hexPort = String.format("%04x", COMMUNICATION_PORT);

		headerBuilder.append(hexPort);
		headerBuilder.append(hexPort);

		USER_DATA_HEADER = headerBuilder.toString();
	}

	public SubmitRequestMessage(String destinationAddress, String data) {
		super(MessageType.SubmitMessageRequest);
		addParameter(CIMDParameterType.DestinationAddress, destinationAddress);
		addParameter(CIMDParameterType.UserData, data);
		addParameter(CIMDParameterType.UserDataHeader, USER_DATA_HEADER);
	}
}
