/**
 * 
 */
package edu.agh.sm2006.smschess.server.config;

import org.kohsuke.args4j.Option;

/**
 * @author Kuba Madej
 * 
 */
public class Configuration implements CIMDConfiguration,
		XBoardEngineConfiguration {
	@Option(name = "-smschost", usage = "SMSC server host", required = true)
	private String smscHost;

	@Option(name = "-smscport", usage = "SMSC server port", required = true)
	private int smscPort;

	@Option(name = "-smscuser", usage = "SMSC server user name", required = true)
	private String smscUsername;

	@Option(name = "-smscpass", usage = "SMSC server password", required = true)
	private String smscPassword;

	@Option(name = "-xboard", usage = "xboard engine launch command", required = true)
	private String xboardCommand;

	@Option(name = "-xboardmax", usage = "maximum number of xboard engine processes, default is 10")
	private int maxXboardProcesses = 10;

	public String getCIMDHost() {
		return smscHost;
	}
	
	public String getCIMDPassword() {
		return smscPassword;
	}

	public int getCIMDPort() {
		return smscPort;
	}

	public String getCIMDUserName() {
		return smscUsername;
	}

	public int getMaxProcesses() {
		return maxXboardProcesses;
	}

	public String getXBoardEngineStartCommand() {
		return xboardCommand;
	}
}
