/**
 *
 */
package edu.agh.sm2006.smschess.server.message.client2server;

import org.apache.log4j.Logger;

import edu.agh.sm2006.smschess.server.message.MalformedMessageException;
import edu.agh.sm2006.smschess.server.session.SessionManager;

/**
 * @author Kuba Madej
 * 
 */
public abstract class AbstractClientToServerMessage implements
		ClientToServerMessage {
	/**
	 * Logger for this class
	 */
	private static final Logger logger = Logger
			.getLogger(AbstractClientToServerMessage.class);

	protected SessionManager sessionManager;

	protected String sessionId;

	protected String senderId;

	/**
	 * @param senderId
	 *            the senderId to set
	 */
	public void setSenderId(String senderId) {
		this.senderId = senderId;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see edu.agh.sm2006.smschess.server.message.client2server.CLientToServerMessage#process()
	 */
	public abstract String process();

	public void setParameters(String... parameters)
			throws MalformedMessageException {
		if (parameters.length < 1) {
			logger.error("Malformed message received");
			return;
		}
		sessionId = parameters[0];
	}

	/**
	 * @param sessionManager
	 *            the sessionManager to set
	 */
	public void setSessionManager(SessionManager sessionManager) {
		this.sessionManager = sessionManager;
	}

}
