/**
 *
 */
package edu.agh.sm2006.smschess.server.message.client2server;

import edu.agh.sm2006.smschess.server.message.server2client.IllegalSessionIdMessage;
import edu.agh.sm2006.smschess.server.message.server2client.PublicSessionNotFoundMessage;
import edu.agh.sm2006.smschess.server.message.server2client.SessionJoinedMessage;
import edu.agh.sm2006.smschess.server.message.server2client.SuccessMessage;
import edu.agh.sm2006.smschess.server.session.InvalidSessionIdException;
import edu.agh.sm2006.smschess.server.session.PublicSessionNotFoundException;

/**
 * Joins client to the given session, either private or public. Format:
 * j:sessionId . Session id is optional (can be left empty) - the client is than
 * joined to any opened public session.
 *
 * @author Kuba Madej
 *
 */
public class JoinSessionMessage extends AbstractClientToServerMessage {
	@Override
	public String process() {
		try {
			if ("".equals(sessionId)) {
				final String sessionId = sessionManager.joinSession(senderId);
				return new SessionJoinedMessage(sessionId).toString();
			} else {
				sessionManager.joinSession(senderId, sessionId);
				return new SuccessMessage().toString();
			}
		} catch (InvalidSessionIdException e) {
			return new IllegalSessionIdMessage().toString();
		} catch (PublicSessionNotFoundException e) {
			return new PublicSessionNotFoundMessage().toString();
		}
	}
}
