/**
 *
 */
package edu.agh.sm2006.smschess.server.message.client2server;

import ictk.boardgame.IllegalMoveException;
import edu.agh.sm2006.smschess.server.message.MalformedMessageException;
import edu.agh.sm2006.smschess.server.message.server2client.GameOverMessage;
import edu.agh.sm2006.smschess.server.message.server2client.IllegalMoveMessage;
import edu.agh.sm2006.smschess.server.message.server2client.IllegalSessionIdMessage;
import edu.agh.sm2006.smschess.server.message.server2client.SuccessMessage;
import edu.agh.sm2006.smschess.server.session.Session;

/**
 * Representation of this message: m:sessionId:move
 * 
 * @author Kuba Madej
 * 
 */
public class MoveMessage extends AbstractClientToServerMessage {

	private String move;

	/*
	 * (non-Javadoc)
	 * 
	 * @see edu.agh.sm2006.smschess.server.message.SMSChessMessage#process()
	 */
	public String process() {
		Session session = sessionManager.getSession(sessionId);
		if (session != null) {
			try {
				if (!session.move(move)) {
					sessionManager.terminateSession(sessionId);
					return new GameOverMessage().toString();
				}
				return new SuccessMessage().toString();
			} catch (IllegalMoveException e) {
				return new IllegalMoveMessage().toString();
			}
		} else {
			return new IllegalSessionIdMessage().toString();
		}
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see edu.agh.sm2006.smschess.server.message.SMSChessMessage#setParameters(java.lang.String[])
	 */
	public void setParameters(String... parameters)
			throws MalformedMessageException {
		super.setParameters(parameters);

		if (parameters.length < 2)
			throw new MalformedMessageException();

		move = parameters[1];
	}

}
