/**
 *
 */
package edu.agh.sm2006.smschess.server.message.server2client;

import edu.agh.sm2006.smschess.server.message.MessageType;

/**
 * Sent when game is over. Format: g:[move] . Move is an optional parameter sent
 * when end of the game occurs as a result of move of another player. In the
 * other case (when game over occurs as a result of move of the player the
 * message is sent to) move parameter is empty.
 *
 * @author Kuba Madej
 *
 */
public class GameOverMessage extends ServerToClientMessage {

	public GameOverMessage(final String move) {
		super(MessageType.GameOver, move);
	}

	public GameOverMessage() {
		super(MessageType.GameOver, "");
	}
}
