/**
 *
 */
package edu.agh.sm2006.smschess.server.session;

import ictk.boardgame.IllegalMoveException;
import edu.agh.sm2006.smschess.server.Connector;
import edu.agh.sm2006.smschess.server.message.server2client.GameOverMessage;
import edu.agh.sm2006.smschess.server.message.server2client.MoveMessage;
import edu.agh.sm2006.smschess.server.message.server2client.QuitMessage;

/**
 * Human session.
 *
 * @author Kuba Madej
 *
 */
public class HumanSession extends Session {
	private String blackPlayer;

	private boolean isPublic;

	public HumanSession(final String sesionId, SessionManager sessionManager,
			Connector connector, String userId, final boolean isPublic) {
		super(sesionId, sessionManager, connector, userId);
		this.isPublic = isPublic;
	}

	public void join(String secondaryPlayerId) throws InvalidSessionIdException {
		if (this.blackPlayer != null)
			throw new InvalidSessionIdException();
		this.blackPlayer = secondaryPlayerId;
	}

	/*
	 * (non-Javadoc)
	 *
	 * @see edu.agh.sm2006.smschess.server.session.Session#move(java.lang.String)
	 */
	@Override
	public boolean move(String move) throws IllegalMoveException {
		final boolean moveResult = super.move(move);
		connector.sendMessage(chessBoard.getPlayerToMove() == 0 ? whitePlayer
				: blackPlayer, moveResult ? new MoveMessage(move).toString()
				: new GameOverMessage(move).toString());
		return moveResult;
	}

	@Override
	public void terminate(boolean notify) {
		if (notify)
			connector.sendMessage(getSecondaryPlayerId(), new QuitMessage()
					.toString());
	}

	public String getSecondaryPlayerId() {
		return blackPlayer;
	}

	public boolean isPublic() {
		return isPublic;
	}
}
