/**
 *
 */
package edu.agh.sm2006.smschess.server.session;

import java.util.Calendar;
import java.util.Map;
import java.util.TimerTask;

/**
 * @author Kuba Madej
 *
 */
public class SessionCollectorTask extends TimerTask {
	private SessionManager sessionManager;

	public SessionCollectorTask(SessionManager manager) {
		sessionManager = manager;
	}

	/*
	 * (non-Javadoc)
	 *
	 * @see java.util.TimerTask#run()
	 */
	@Override
	public void run() {
		collectTimedOutSessions(sessionManager.getHumanSessions());
		collectTimedOutSessions(sessionManager.getXBoardSessions());
	}

	private void collectTimedOutSessions(Map<String, ? extends Session> sessions) {
		Calendar calendar = Calendar.getInstance();
		calendar.add(Calendar.DAY_OF_YEAR, -1);
		for (Session session : sessions.values()) {
			Calendar lastMove = Calendar.getInstance();
			lastMove.setTime(session.getLastMove());
			if (calendar.compareTo(lastMove) > 0) {
				sessionManager.terminateSession(session.getSessionId());
			}
		}
	}

}
