/**
 *
 */
package edu.agh.sm2006.smschess.server.session.xboard;

import edu.agh.sm2006.smschess.server.config.XBoardEngineConfiguration;

/**
 * @author Kuba Madej
 *
 */
public class XBoardEngineProcessManager {
	private int maxProcesses;

	private int processes;

	private String command;

	/**
	 *
	 * @param configuration
	 */
	public XBoardEngineProcessManager(XBoardEngineConfiguration configuration) {
		maxProcesses = configuration.getMaxProcesses();
		command = configuration.getXBoardEngineStartCommand();
	}

	/**
	 *
	 * @param sessionId
	 * @param playWhite
	 * @return newly created process or null if maximum number of processes has
	 *         been reached
	 * @throws XBoardEngineProcessException
	 */
	public XBoardEngineProcess createProcess(final String sessionId,
			boolean playWhite) throws XBoardEngineProcessException {
		if (maxProcesses > 0 && processes == maxProcesses) {
			return null;
		}
		XBoardEngineProcess process = new XBoardEngineProcess(command,
				playWhite);
		processes++;
		return process;
	}

	public void releaseProcess() {
		processes--;
	}
}
