/**
 *
 */
package edu.agh.sm2006.smschess.server.socket;

import java.io.IOException;
import java.net.ServerSocket;
import java.net.Socket;
import java.net.UnknownHostException;
import java.util.HashMap;
import java.util.Map;

import edu.agh.sm2006.smschess.server.Connector;
import edu.agh.sm2006.smschess.server.config.Configuration;
import edu.agh.sm2006.smschess.server.message.MessageParser;

/**
 * @author Kuba Madej
 *
 */
public class SocketConnector implements Connector {

	public static final int DEFAULT_PORT = 12345;

	private ServerSocket serverSocket;

	private MessageParser chessMessageParser;

	private int clientId;

	private Map<Integer, Client> clients = new HashMap<Integer, Client>();

	public SocketConnector(Configuration confugiration) {
	}

	/*
	 * (non-Javadoc)
	 *
	 * @see edu.agh.sm2006.smschess.server.Connector#openConnection(edu.agh.sm2006.smschess.server.message.SMSChessMessageParser)
	 */
	public void openConnection(MessageParser chessMessageParser) {
		try {
			serverSocket = new ServerSocket(DEFAULT_PORT);
		} catch (UnknownHostException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		this.chessMessageParser = chessMessageParser;
	}

	/*
	 * (non-Javadoc)
	 *
	 * @see edu.agh.sm2006.smschess.server.Connector#runReceiver()
	 */
	public void runReceiver() {
		while (true) {
			try {
				Socket socket = serverSocket.accept();
				int id = clientId++;
				clients.put(id, new Client(id, socket, chessMessageParser));
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
	}

	public void sendMessage(String receiver, String messageContent) {
		clients.get(Integer.parseInt(receiver)).sendMessage(messageContent);
	}

}
